# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_xrdcertificateconfiguration`](#dsc_xrdcertificateconfiguration): The DSC xRDCertificateConfiguration resource type. Automatically generated from version 2.1.0
* [`dsc_xrdgatewayconfiguration`](#dsc_xrdgatewayconfiguration): The DSC xRDGatewayConfiguration resource type. Automatically generated from version 2.1.0
* [`dsc_xrdlicenseconfiguration`](#dsc_xrdlicenseconfiguration): The DSC xRDLicenseConfiguration resource type. Automatically generated from version 2.1.0
* [`dsc_xrdremoteapp`](#dsc_xrdremoteapp): The DSC xRDRemoteApp resource type. Automatically generated from version 2.1.0
* [`dsc_xrdserver`](#dsc_xrdserver): The DSC xRDServer resource type. Automatically generated from version 2.1.0
* [`dsc_xrdsessioncollection`](#dsc_xrdsessioncollection): The DSC xRDSessionCollection resource type. Automatically generated from version 2.1.0
* [`dsc_xrdsessioncollectionconfiguration`](#dsc_xrdsessioncollectionconfiguration): The DSC xRDSessionCollectionConfiguration resource type. Automatically generated from version 2.1.0
* [`dsc_xrdsessiondeployment`](#dsc_xrdsessiondeployment): The DSC xRDSessionDeployment resource type. Automatically generated from version 2.1.0

## Resource types

### <a name="dsc_xrdcertificateconfiguration"></a>`dsc_xrdcertificateconfiguration`

The DSC xRDCertificateConfiguration resource type.
Automatically generated from version 2.1.0

#### Properties

The following properties are available in the `dsc_xrdcertificateconfiguration` type.

##### `dsc_importpath`

Data type: `String`

The certificate that should be used, should point to a PFX file on the filesystem.

#### Parameters

The following parameters are available in the `dsc_xrdcertificateconfiguration` type.

* [`dsc_connectionbroker`](#dsc_connectionbroker)
* [`dsc_credential`](#dsc_credential)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_role`](#dsc_role)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_connectionbroker"></a>`dsc_connectionbroker`

namevar

Data type: `String`

The connection broker that this certificate configuration is applied to.

##### <a name="dsc_credential"></a>`dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Specifies the password used to decrypt the PFX file. The username is ignored.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_role"></a>`dsc_role`

namevar

Data type: `Enum['RDRedirector', 'RDPublishing', 'RDWebAccess', 'RDGateway']`

The role to apply this certificate configuration to.

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xrdgatewayconfiguration"></a>`dsc_xrdgatewayconfiguration`

The DSC xRDGatewayConfiguration resource type.
Automatically generated from version 2.1.0

#### Properties

The following properties are available in the `dsc_xrdgatewayconfiguration` type.

##### `dsc_bypasslocal`

Data type: `Optional[Boolean]`

 

##### `dsc_externalfqdn`

Data type: `Optional[String]`

 

##### `dsc_gatewaymode`

Data type: `Optional[Enum['DoNotUse', 'Custom', 'Automatic']]`

 

##### `dsc_gatewayserver`

Data type: `Optional[String]`

 

##### `dsc_logonmethod`

Data type: `Optional[Enum['Password', 'Smartcard', 'AllowUserToSelectDuringConnection']]`

 

##### `dsc_usecachedcredentials`

Data type: `Optional[Boolean]`

 

#### Parameters

The following parameters are available in the `dsc_xrdgatewayconfiguration` type.

* [`dsc_connectionbroker`](#dsc_connectionbroker)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_connectionbroker"></a>`dsc_connectionbroker`

namevar

Data type: `String`

 

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xrdlicenseconfiguration"></a>`dsc_xrdlicenseconfiguration`

The DSC xRDLicenseConfiguration resource type.
Automatically generated from version 2.1.0

#### Properties

The following properties are available in the `dsc_xrdlicenseconfiguration` type.

##### `dsc_licensemode`

Data type: `Enum['PerUser', 'PerDevice', 'NotConfigured']`

 

##### `dsc_licenseserver`

Data type: `Optional[Array[String]]`

 

#### Parameters

The following parameters are available in the `dsc_xrdlicenseconfiguration` type.

* [`dsc_connectionbroker`](#dsc_connectionbroker)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_connectionbroker"></a>`dsc_connectionbroker`

namevar

Data type: `String`

 

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xrdremoteapp"></a>`dsc_xrdremoteapp`

The DSC xRDRemoteApp resource type.
Automatically generated from version 2.1.0

#### Properties

The following properties are available in the `dsc_xrdremoteapp` type.

##### `dsc_commandlinesetting`

Data type: `Optional[Enum['Allow', 'DoNotAllow', 'Require']]`

Specifies whether the RemoteApp program accepts command-line arguments from the client at connection time. The acceptable values for this parameter are:  Allow, DoNotAllow, Require

##### `dsc_displayname`

Data type: `String`

Specifies a name to display to users for the RemoteApp program.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Present if the RemoteApp should exist, Absent if it should be removed

##### `dsc_filepath`

Data type: `String`

Specifies a path for the executable file for the application. Do not include any environment variables.

##### `dsc_filevirtualpath`

Data type: `Optional[String]`

Specifies a path for the application executable file. This path resolves to the same location as the value of the FilePath parameter, but it can include environment variables. 

##### `dsc_foldername`

Data type: `Optional[String]`

Specifies the name of the folder that the RemoteApp program appears in on the Remote Desktop Web Access (RD Web Access) webpage and in the Start menu for subscribed RemoteApp and Desktop Connections. 

##### `dsc_iconindex`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the index within the icon file (specified by the IconPath parameter) where the RemoteApp program's icon can be found.

##### `dsc_iconpath`

Data type: `Optional[String]`

Specifies the path to a file containing the icon to display for the RemoteApp program identified by the Alias parameter.

##### `dsc_requiredcommandline`

Data type: `Optional[String]`

Specifies a string that contains command-line arguments that the client can use at connection time with the RemoteApp program. 

##### `dsc_showinwebaccess`

Data type: `Optional[Boolean]`

Specifies whether to show the RemoteApp program in the RD Web Access server, and in RemoteApp and Desktop Connections that the user subscribes to. 

##### `dsc_usergroups`

Data type: `Optional[Array[String]]`

Specifies a list of domain groups that can view the RemoteApp in RD Web Access, and in RemoteApp and Desktop Connections. To allow all users to see a RemoteApp program, provide a value of Null.

#### Parameters

The following parameters are available in the `dsc_xrdremoteapp` type.

* [`dsc_alias`](#dsc_alias)
* [`dsc_collectionname`](#dsc_collectionname)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_alias"></a>`dsc_alias`

namevar

Data type: `String`

Specifies an alias for the RemoteApp program.

##### <a name="dsc_collectionname"></a>`dsc_collectionname`

namevar

Data type: `String`

Specifies the name of the personal virtual desktop collection or session collection. The cmdlet publishes the RemoteApp
program to this collection.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xrdserver"></a>`dsc_xrdserver`

The DSC xRDServer resource type.
Automatically generated from version 2.1.0

#### Properties

The following properties are available in the `dsc_xrdserver` type.

##### `dsc_connectionbroker`

Data type: `Optional[String]`

 

##### `dsc_gatewayexternalfqdn`

Data type: `Optional[String]`

 

#### Parameters

The following parameters are available in the `dsc_xrdserver` type.

* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_role`](#dsc_role)
* [`dsc_server`](#dsc_server)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_role"></a>`dsc_role`

namevar

Data type: `Enum['RDS-Connection-Broker', 'RDS-Virtualization', 'RDS-RD-Server', 'RDS-Web-Access', 'RDS-Gateway', 'RDS-Licensing']`

 

##### <a name="dsc_server"></a>`dsc_server`

namevar

Data type: `String`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xrdsessioncollection"></a>`dsc_xrdsessioncollection`

The DSC xRDSessionCollection resource type.
Automatically generated from version 2.1.0

#### Properties

The following properties are available in the `dsc_xrdsessioncollection` type.

##### `dsc_collectiondescription`

Data type: `Optional[String]`

Specifies a description for the collection.

##### `dsc_connectionbroker`

Data type: `Optional[String]`

Specifies the Remote Desktop Connection Broker (RD Connection Broker) server for a Remote Desktop deployment.

#### Parameters

The following parameters are available in the `dsc_xrdsessioncollection` type.

* [`dsc_collectionname`](#dsc_collectionname)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_sessionhost`](#dsc_sessionhost)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_collectionname"></a>`dsc_collectionname`

namevar

Data type: `String`

Specifies a name for the session collection. 

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_sessionhost"></a>`dsc_sessionhost`

namevar

Data type: `String`

Specifies an RD Session Host server to include in the session collection. 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xrdsessioncollectionconfiguration"></a>`dsc_xrdsessioncollectionconfiguration`

The DSC xRDSessionCollectionConfiguration resource type.
Automatically generated from version 2.1.0

#### Properties

The following properties are available in the `dsc_xrdsessioncollectionconfiguration` type.

##### `dsc_activesessionlimitmin`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the maximum time, in minutes, an active session runs. After this period, the RD Session Host server ends the session. 

##### `dsc_authenticateusingnla`

Data type: `Optional[Boolean]`

Indicates whether to use Network Level Authentication (NLA). If this value is $True, Remote Desktop uses NLA to authenticate a user before the user sees a logon screen. 

##### `dsc_automaticreconnectionenabled`

Data type: `Optional[Boolean]`

Indicates whether the Remote Desktop client attempts to reconnect after a connection interruption. 

##### `dsc_brokenconnectionaction`

Data type: `Optional[String]`

Specifies an action for an RD Session Host server to take after a connection interruption. The acceptable values for this parameter are: None, Disconnect, LogOff.

##### `dsc_clientdeviceredirectionoptions`

Data type: `Optional[String]`

Specifies a type of client device to be redirected to an RD Session Host server in this session collection. The acceptable values for this parameter are: None, AudioVideoPlayBack, AudioRecording, COMPort, PlugAndPlayDevice, SmartCard, Clipboard, LPTPort, Drive, TimeZone.  You can use binary-or to combine two or more values of this enum to specify multiple client device types.

##### `dsc_clientprinterasdefault`

Data type: `Optional[Boolean]`

Indicates whether to use the client printer or server printer as the default printer. If this value is $True, use the client printer as default. If this value is $False, use the server as default.

##### `dsc_clientprinterredirected`

Data type: `Optional[Boolean]`

Indicates whether to use client printer redirection, which routes print jobs from the Remote Desktop session to a printer attached to the client computer.

##### `dsc_collectiondescription`

Data type: `Optional[String]`

Specifies a description of the session collection. 

##### `dsc_connectionbroker`

Data type: `Optional[String]`

Specifies the Remote Desktop Connection Broker (RD Connection Broker) server for a Remote Desktop deployment.

##### `dsc_customrdpproperty`

Data type: `Optional[String]`

Specifies Remote Desktop Protocol (RDP) settings to include in the .rdp files for all Windows Server 2012 RemoteApp programs and remote desktops published in this collection. 

##### `dsc_disconnectedsessionlimitmin`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies a length of time, in minutes. After client disconnection from a session for this period, the RD Session Host ends the session.

##### `dsc_diskpath`

Data type: `Optional[String]`

Specifies the target to store the User Profile Disks 

##### `dsc_enableuserprofiledisk`

Data type: `Optional[Boolean]`

Specifies if this collection uses UserProfileDisks 

##### `dsc_encryptionlevel`

Data type: `Optional[String]`

Specifies the level of data encryption used for a Remote Desktop session. The acceptable values for this parameter are: Low, ClientCompatible, High, FipsCompliant. The default value is ClientCompatible.

##### `dsc_excludefilepath`

Data type: `Optional[Array[String]]`

Specifies a list of strings for files to exclude from the user profile disk 

##### `dsc_excludefolderpath`

Data type: `Optional[Array[String]]`

Specifies a list of strings for folders to exclude from the user profile disk 

##### `dsc_idlesessionlimitmin`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the length of time, in minutes, to wait before an RD Session Host logs off or disconnects an idle session. The BrokenConnectionAction parameter determines whether to log off or disconnect. 

##### `dsc_includefilepath`

Data type: `Optional[Array[String]]`

Specifies a list of strings for files to include in the user profile disk 

##### `dsc_includefolderpath`

Data type: `Optional[Array[String]]`

Specifies a list of strings for folders to include in the user profile disk 

##### `dsc_maxredirectedmonitors`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the maximum number of client monitors that an RD Session Host server can redirect to a remote session. The highest value for this parameter is 16.

##### `dsc_maxuserprofiledisksizegb`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the maximum size in GB for a User Profile Disk 

##### `dsc_rdeasyprintdriverenabled`

Data type: `Optional[Boolean]`

Specifies whether to enable the Remote Desktop Easy Print driver.

##### `dsc_securitylayer`

Data type: `Optional[String]`

Specifies which security protocol to use. The acceptable values for this parameter are:  RDP, Negotiate, SSL.  The default value is Negotiate.

##### `dsc_temporaryfoldersdeletedonexit`

Data type: `Optional[Boolean]`

Specifies whether to delete temporary folders from the RD Session Host server for a disconnected session. 

##### `dsc_usergroup`

Data type: `Optional[String]`

Specifies a domain group authorized to connect to the RD Session Host servers in a session collection. 

#### Parameters

The following parameters are available in the `dsc_xrdsessioncollectionconfiguration` type.

* [`dsc_collectionname`](#dsc_collectionname)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_collectionname"></a>`dsc_collectionname`

namevar

Data type: `String`

Specifies the name of a session collection. 

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xrdsessiondeployment"></a>`dsc_xrdsessiondeployment`

The DSC xRDSessionDeployment resource type.
Automatically generated from version 2.1.0

#### Parameters

The following parameters are available in the `dsc_xrdsessiondeployment` type.

* [`dsc_connectionbroker`](#dsc_connectionbroker)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_sessionhost`](#dsc_sessionhost)
* [`dsc_webaccessserver`](#dsc_webaccessserver)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_connectionbroker"></a>`dsc_connectionbroker`

namevar

Data type: `String`

Specifies the FQDN of a server to host the RD Connection Broker role service.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_sessionhost"></a>`dsc_sessionhost`

namevar

Data type: `String`

Specifies the FQDN of a server to host the RD Session Host role service. 

##### <a name="dsc_webaccessserver"></a>`dsc_webaccessserver`

namevar

Data type: `String`

Specifies the FQDN of a server to host the RD Web Access role service. 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

